Package org.apache.sis.metadata.iso.extent

# Class DefaultTemporalExtent

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultTemporalExtent

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `TemporalExtent`

Direct Known Subclasses:
  `DefaultSpatialTemporalExtent`

public class DefaultTemporalExtent extends ISOMetadata implements TemporalExtent
Time period covered by the content of the dataset. The following property is mandatory in a well-formed metadata according ISO 19115:
`EX_TemporalExtent` `└─extent…………………` The date and time for the content of the dataset.
In addition to the standard properties, SIS provides the following methods:

- `getStartTime()` for fetching the start time from the temporal primitive.
- `getEndTime()` for fetching the end time from the temporal primitive.
- `setBounds(Date, Date)` for setting the extent from the given start and end time.
- `setBounds(Envelope)` for setting the extent from the given envelope.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultTemporalExtent()`
  Constructs an initially empty temporal extent.
  `DefaultTemporalExtent(TemporalExtent object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultTemporalExtent`
  `castOrCopy(TemporalExtent object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Date`
  `getEndTime()`
  Returns the end date and time for the content of the dataset.
  `TemporalPrimitive`
  `getExtent()`
  Returns the date and time for the content of the dataset.
  `Date`
  `getStartTime()`
  The start date and time for the content of the dataset.
  `void`
  `intersect(TemporalExtent other)`
  Sets this temporal extent to the intersection of this extent with the specified one.
  `void`
  `setBounds(Date startTime, Date endTime)`
  Sets the temporal extent to the specified values.
  `void`
  `setBounds(Envelope envelope)`
  Sets this temporal extent to values inferred from the specified envelope.
  `void`
  `setExtent(TemporalPrimitive newValue)`
  Sets the date and time for the content of the dataset.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultTemporalExtent

    public DefaultTemporalExtent()
    Constructs an initially empty temporal extent.

  - ### DefaultTemporalExtent

    public DefaultTemporalExtent(TemporalExtent object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(TemporalExtent)`

- ## Method Details

  - ### castOrCopy

    public static DefaultTemporalExtent castOrCopy(TemporalExtent object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is an instance of `SpatialTemporalExtent`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass.
    - Otherwise if the given object is already an instance of `DefaultTemporalExtent`, then it is returned unchanged.
    - Otherwise a new `DefaultTemporalExtent` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getExtent

    public TemporalPrimitive getExtent()
    Returns the date and time for the content of the dataset. If no extent has been explicitly set, then this method will build an extent from the start time and end time if any.
    Specified by:
      `getExtent` in interface `TemporalExtent`
    Returns:
      the date and time for the content, or `null`.

  - ### setExtent

    public void setExtent(TemporalPrimitive newValue)
    Sets the date and time for the content of the dataset.
    Parameters:
      `newValue` - the new content date.

  - ### getStartTime

    public Date getStartTime()
    The start date and time for the content of the dataset. This method tries to infer it from the extent.
    Returns:
      the start time, or `null` if none.

  - ### getEndTime

    public Date getEndTime()
    Returns the end date and time for the content of the dataset. This method tries to infer it from the extent.
    Returns:
      the end time, or `null` if none.

  - ### setBounds

    public void setBounds(Date startTime, Date endTime) throws UnsupportedOperationException
    Sets the temporal extent to the specified values. This convenience method creates a temporal primitive for the given dates, then invokes `setExtent(TemporalPrimitive)`.

    Note: this method is available only if the `sis-temporal` module is available on the classpath, or any other module providing an implementation of the `TemporalFactory` interface.

    Parameters:
      `startTime` - the start date and time for the content of the dataset, or `null` if none.
      `endTime` - the end date and time for the content of the dataset, or `null` if none.
    Throws:
      `UnsupportedOperationException` - if no implementation of `TemporalFactory` has been found on the classpath.

  - ### setBounds

    public void setBounds(Envelope envelope) throws TransformException
    Sets this temporal extent to values inferred from the specified envelope. The given envelope must have a CRS, and at least one dimension of that CRS shall be assignable to a property of this extent.

    Note: this method is available only if the `sis-referencing` module is available on the classpath.

    Parameters:
      `envelope` - the envelope to use for setting this temporal extent.
    Throws:
      `UnsupportedOperationException` - if the referencing module or the temporal module is not on the classpath.
      `TransformException` - if the envelope can not be transformed to a temporal extent.
    See Also:
      - `DefaultExtent​.addElements(Envelope)`
      - `DefaultGeographicBoundingBox​.setBounds(Envelope)`
      - `DefaultVerticalExtent​.setBounds(Envelope)`

  - ### intersect

    public void intersect(TemporalExtent other)
    Sets this temporal extent to the intersection of this extent with the specified one. If there is no intersection between the two extents, then this method sets the temporal primitive to nil. If either this extent or the specified extent has nil primitive, then the intersection result will also be nil.
    Parameters:
      `other` - the temporal extent to intersect with this extent.
    Throws:
      `UnsupportedOperationException` - if no implementation of `TemporalFactory` has been found on the classpath.
    Since:
      0.8
    See Also:
      - `Extents​.intersection(TemporalExtent, TemporalExtent)`
      - `GeneralEnvelope​.intersect(Envelope)`